/* RXCRC.CMD - CRC generator and comparison program
   Copyright (C) Bruce Eric Hgman 1995. All Rights Reserved.
   License information is provided in the RXCRC.INF file.
   For instructions on the use of this program, use VIEW RXCRC
*/
parse source osname cmdname ourname
Version='1.0 95-02-08'
'@cls'
header = center(time('n') || ' ' ||,
   'RXCRC - CRC File Comparison Tool   Vers 'Version,80)
call charout ,d2c(27)'[0;1;33;44m'header||d2c(27)'[0;1;37;40m'
call charout ,d2c(27)'[K'
start_time = time('s')
start_tod  = time('n')
RXCRC_RC = 0

call Define_Globals

call Load_DLLs

parse arg command_line
call Parse_Arguments

return RXCRC_RC


/*
Ŀ
                                                       
  Com_Compare()  process comparison                    
  Input:  com_data_file*,  com_dir_lvl,                
          com_name_file*,  com_sort_names,             
          com_text_*,      start_time                  
          com_output_*                                 
  Output: writes to com_output_match/unmat,excep       
  Returns: null                                        

*/
Com_Compare: procedure expose (com_globals)

   if \abbrev(stream(com_output_match,'c','open write'),'READY') then
      call exit 'Unable to open' com_output_match 'for output.'
   call lineout com_output_match,com_text_match
   call lineout com_output_match,,
      left(com_input_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_input_fileb

   call lineout com_output_match,,
      left(com_text_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_text_fileb

   if \abbrev(stream(com_output_unmat,'c','open write'),'READY') then
      call exit 'Unable to open' com_output_unmat 'for output.'
   call lineout com_output_unmat,com_text_unmat
   call lineout com_output_unmat,,
      left(com_input_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_input_fileb

   call lineout com_output_unmat,,
      left(com_text_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_text_fileb

   if \abbrev(stream(com_output_excep,'c','open write'),'READY') then
      call exit 'Unable to open' com_output_excep 'for output.'
   call lineout com_output_excep,com_text_excep
   call lineout com_output_excep,,
      left(com_input_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_input_fileb

   call lineout com_output_excep,,
      left(com_text_filea||copies(' ',com_max_oline_filea),,
      com_max_oline_filea) || copies(' ',5) ||,
      com_text_fileb

   if \abbrev(stream(com_output_unmat,'c','open write'),'READY') then
      call exit 'Unable to open' com_output_unmat 'for output.'

   if \abbrev(stream(com_output_excep,'c','open write'),'READY') then
      call exit 'Unable to open' com_output_excep 'for output.'

   say time('n') 'Begin Compare phase match'
   xl1 = 'Input:   filea:     ' com_input_filea
   xl2 = '         fileb:     ' com_input_fileb
   xl3 = 'Output:  match file:' com_output_match
   xl4 = '       unmatch file:' com_output_unmat
   xl5 = '     exception file:' com_output_excep
   ll1 = length(xl1); ll2 = length(xl2); ll3 = length(xl3)
   ll4 = length(xl4); ll5 = length(xl5)
   mxl = max(ll1,ll2,ll3,ll4,ll5)
   xl1 = left(xl1||copies(' ',mxl),mxl)
   xl2 = left(xl2||copies(' ',mxl),mxl)
   xl3 = left(xl3||copies(' ',mxl),mxl)
   xl4 = left(xl4||copies(' ',mxl),mxl)
   xl5 = left(xl5||copies(' ',mxl),mxl)
   say xl1 || '  ' || com_data_filea.0 'lines'
   say xl2 || '  ' || com_data_fileb.0 'lines'
   call charout ,xl3 d2c(27)'[s'
   say ''
   say xl4
   say xl5
   drop xl1 xl2 xl3 xl4 xl5 ll1 ll2 ll3 ll4 ll5 mxl

   /* line counters for output */
   com_lines_match = 0
   com_lines_unmat = 0
   com_lines_excep = 0

   com_max_nwidth = length(com_data_filea.0)

   /* com_name_file*. stem var contains constructed match names */
   com_name_filea. = ''
   com_name_fileb. = ''
   com_name_filea.0 = com_data_filea.0
   com_name_fileb.0 = com_data_fileb.0
   do i = 1 to com_data_filea.0
      com_name_filea.i = Com_Make_Name(com_data_filea.i,com_dir_lvl)
   end
   do i = 1 to com_data_fileb.0
      com_name_fileb.i = Com_Make_Name(com_data_fileb.i,com_dir_lvl)
   end
   if com_sort_names then call Com_Sort_Names

   com_name_match_filea.=0
   com_name_match_fileb.=0

   idx_filea = 1
   idx_fileb = 1
   k = com_name_filea.0 + 1
   com_name_filea.k = copies('ff'x,260)
   k = com_name_fileb.0 + 1
   com_name_fileb.k = copies('ff'x,260)
   do while idx_filea < com_name_filea.0 | idx_fileb < com_name_fileb.0
      select
         when com_name_filea.idx_filea = com_name_fileb.idx_fileb then
            do
               /* leave on reaching  end of table */
               if 'ff'x = left(com_name_filea.idx_filea,1) then leave

               /* mark name match entries */
               com_name_match_filea.idx_filea = 1
               com_name_match_fileb.idx_fileb = 1

               if Com_Check_Match(com_data_filea.idx_filea,,
                                  com_data_fileb.idx_fileb) then
                  call Com_Write_Match com_data_filea.idx_filea,,
                                       com_data_fileb.idx_fileb
               else
                  call Com_Write_Unmat com_data_filea.idx_filea,,
                                       com_data_fileb.idx_fileb
               idx_filea = idx_filea + 1
               idx_fileb = idx_fileb + 1
            end

         /* if filea has lower name, search for match in fileb */
         when com_name_filea.idx_filea < com_name_fileb.idx_fileb then
         do
            do ib = idx_fileb+1 to com_name_fileb.0
               if com_name_filea.idx_filea = com_name_fileb.ib then
                  do
                     com_name_match_filea.idx_filea = 1
                     com_name_match_fileb.ib = 1
                     if Com_Check_Match(com_data_filea.idx_filea,,
                                        com_data_fileb.ib) then
                        call Com_Write_Match com_data_filea.idx_filea,,
                                             com_data_fileb.ib
                     else
                        call Com_Write_Unmat com_data_filea.idx_filea,,
                                             com_data_fileb.ib
                  end
                  leave
            end
            if \com_name_match_filea.idx_filea then
               call Com_Write_Excep com_data_filea.idx_filea,'A'
            idx_filea = idx_filea + 1
         end

         /* otherwise, fileb has lower name, so search for match in filea */
         otherwise
         do
            do ia = idx_filea+1 to com_name_filea.0
               if com_name_filea.ia = com_name_fileb.idx_fileb then
                  do
                     com_name_match_filea.ia = 1
                     com_name_match_fileb.idx_fileb = 1
                     if Com_Check_Match(com_data_filea.ia,,
                                        com_data_fileb.idx_fileb) then
                        call Com_Write_Match com_data_filea.ia,,
                                             com_data_fileb.idx_fileb
                     else
                        call Com_Write_Unmat com_data_filea.ia,,
                                             com_data_fileb.idx_fileb
                     leave
                  end
            end
            if \com_name_match_fileb.idx_fileb then
               call Com_Write_Excep com_data_fileb.idx_fileb,'B'
            idx_fileb = idx_fileb + 1
         end
      end
   end

   call stream com_output_match,'c','close'
   call stream com_output_unmat,'c','close'
   call stream com_output_excep,'c','close'
   match_lines = right(copies(' ',com_max_nwidth)||com_lines_match,com_max_nwidth)
   unmat_lines = right(copies(' ',com_max_nwidth)||com_lines_unmat,com_max_nwidth)
   excep_lines = right(copies(' ',com_max_nwidth)||com_lines_excep,com_max_nwidth)
   call charout ,d2c(27)'[u' match_lines 'lines'
   call charout ,d2c(27)'[u'd2c(27)'[1B' unmat_lines 'lines'
   call charout ,d2c(27)'[u'd2c(27)'[2B' excep_lines 'lines'
   say ''
   end_time = time('s')
   elapsed_time = end_time - start_time
   say time('n') 'Compare processing complete.' elapsed_time 'seconds '||,
      format((com_data_filea.0+com_data_fileb.0)/elapsed_time,,2) 'files/sec'
   return 0


/*
Ŀ
  Com_Check_Match:  compare data from files for match  
  Input:  data string filea, data string fileb         
  Returns: 1:matches, 0:unmatched                      

*/
Com_Check_Match: procedure
   arg data_filea,data_fileb
   parse var data_filea crcvala fsizea fnamea
   parse var data_fileb crcvalb fsizeb fnameb
   if crcvala == crcvalb & fsizea == fsizeb then
      return 1
   else
      return 0


/*
Ŀ
 Com_Make_Name:  create parallel table of names        
 for matching entries and for sorting names.           
 Input:  lines from file* with crc size name           
 Output: name constructed using com_dir_lvl            

*/
Com_Make_Name: procedure
   arg filexline,dirlvl
   parse var filexline crcval file_size fname
   k = length(fname)
   if k < 1 then
      do
         say 'Internal error Com_Make_Name'
         say 'arg: filexline='filexline'<'
         say 'arg: dirlvl   ='dirlvl'<'
         call exit 'Internal error'
      end
   do i = 1 to dirlvl
      j = lastpos('\',fname,k-1)
      if j = 0 then leave
      k = j
   end
   return substr(fname,k)


/*
Ŀ
  Com_Sort_Names - sort both input files' data         
  based on com_dir_lvl constructed match name.         

*/
Com_Sort_Names: procedure expose (com_globals)
   k = com_data_filea.0
   upperlimit = k
   do i = 1
      if \(i < upperlimit) then leave
      highest = com_name_filea.upperlimit
      lowest  = com_name_filea.i
      k = i + 1
      do j = k
         if \(j < upperlimit) then leave
         upper = com_name_filea.j
         if upper < lowest then
            do
               temp   = upper
               upper  = lowest
               lowest = temp
               com_name_filea.i = lowest
               com_name_filea.j = upper

               temp = com_data_filea.i
               com_data_filea.i = com_data_filea.j
               com_data_filea.j = temp
            end
         if upper > highest then
            do
               temp    = highest
               highest = upper
               upper   = temp
               com_name_filea.j = upper
               com_name_filea.upperlimit = highest

               temp = com_data_filea.j
               com_data_filea.j = com_data_filea.upperlimit
               com_data_filea.upperlimit = temp
            end
      end
      upperlimit = upperlimit - 1
   end
   k = com_data_fileb.0
   upperlimit = k
   do i = 1
      if \(i < upperlimit) then leave
      highest = com_name_fileb.upperlimit
      lowest  = com_name_fileb.i
      k = i + 1
      do j = k
         if \(j < upperlimit) then leave
         upper = com_name_fileb.j
         if upper < lowest then
            do
               temp   = upper
               upper  = lowest
               lowest = temp
               com_name_fileb.i = lowest
               com_name_fileb.j = upper

               temp = com_data_fileb.i
               com_data_fileb.i = com_data_fileb.j
               com_data_fileb.j = temp
            end
         if upper > highest then
            do
               temp    = highest
               highest = upper
               upper   = temp
               com_name_fileb.j = upper
               com_name_fileb.upperlimit = highest

               temp = com_data_fileb.j
               com_data_fileb.j = com_data_fileb.upperlimit
               com_data_fileb.upperlimit = temp
            end
      end
      upperlimit = upperlimit - 1
   end
   return
/*
Ŀ
  Com_Write_Match:  write matching entries             
  Input:  data filea, data fileb                       
          com_max_fsize_file*,   com_max_oline_filea   
          com_max_fname_filea                          
  Output: new line written to file                     

*/
Com_Write_Match: procedure expose (com_globals)
   parse arg data_filea,data_fileb
   parse var data_filea crcvala fsizea fnamea
   parse var data_fileb crcvalb fsizeb fnameb
   crca = right(copies(' ',8)||crcvala,8)||' '
   siza = right(copies(' ',com_max_fsize_filea)||fsizea,com_max_fsize_filea)||' '
   nama = left(fnamea||copies(' ',com_max_fname_filea),com_max_fname_filea)
   lina = crca siza nama copies(' ',3)
   crcb = right(copies(' ',8)||crcvalb,8)||' '
   sizb = right(copies(' ',com_max_fsize_fileb)||fsizeb,com_max_fsize_fileb)||' '
   oline = lina crcb sizb fnameb
   call lineout com_output_match,oline
   com_lines_match = com_lines_match + 1
   match_lines = right(copies(' ',com_max_nwidth)||com_lines_match,com_max_nwidth)
   call charout ,d2c(27)'[u' match_lines 'lines'
   return
/*
Ŀ
  Com_Write_Unmat: write unmatching entries            
  Input:  data filea, data fileb                       
          com_max_fsize_file*,   com_max_oline_filea   
          com_max_fname_filea                          
  Output: new line written to file                     

*/
Com_Write_Unmat: procedure expose (com_globals)
   parse arg data_filea,data_fileb
   parse var data_filea crcvala fsizea fnamea
   parse var data_fileb crcvalb fsizeb fnameb
   crca = right(copies(' ',8)||crcvala,8)||' '
   siza = right(copies(' ',com_max_fsize_filea)||fsizea,com_max_fsize_filea)||' '
   nama = left(fnamea||copies(' ',com_max_fname_filea),com_max_fname_filea)
   lina = crca siza nama copies(' ',3)
   crcb = right(copies(' ',8)||crcvalb,8)||' '
   sizb = right(copies(' ',com_max_fsize_fileb)||fsizeb,com_max_fsize_fileb)||' '
   oline = lina crcb sizb fnameb
   call lineout com_output_unmat,oline
   com_lines_unmat = com_lines_unmat + 1
   unmat_lines = right(copies(' ',com_max_nwidth)||com_lines_unmat,com_max_nwidth)
   call charout ,d2c(27)'[u'd2c(27)'[1B' unmat_lines 'lines'
   return
/*
Ŀ
  Com_Write_Excep:  write exception entries            
  Input:  data filea, data fileb                       
          com_max_fsize_file*,   com_max_oline_filea   
          com_max_fname_filea                          
  Output: new line written to file                     

*/
Com_Write_Excep: procedure expose (com_globals)
   parse arg data_filex,which
   if which = 'A' then
      do
         data_filea = data_filex
         data_fileb = ''
      end
   else
      do
         data_filea = ''
         data_fileb = data_filex
      end
   parse var data_filea crcvala fsizea fnamea
   parse var data_fileb crcvalb fsizeb fnameb
   crca = right(copies(' ',8)||crcvala,8)||' '
   siza = right(copies(' ',com_max_fsize_filea)||fsizea,com_max_fsize_filea)||' '
   nama = left(fnamea||copies(' ',com_max_fname_filea),com_max_fname_filea)
   lina = crca siza nama copies(' ',3)
   crcb = right(copies(' ',8)||crcvalb,8)||' '
   sizb = right(copies(' ',com_max_fsize_fileb)||fsizeb,com_max_fsize_fileb)||' '
   oline = lina crcb sizb fnameb
   call lineout com_output_excep,oline
   com_lines_excep = com_lines_excep + 1
   excep_lines = right(copies(' ',com_max_nwidth)||com_lines_excep,com_max_nwidth)
   call charout ,d2c(27)'[u'd2c(27)'[2B' excep_lines 'lines'
   return
/*
Ŀ
                                                       
  Create_Output_File                                   
                                                       
  Input:  position, command_line                       
  Output: file created, with directories as needed     

*/
Create_Output_File: procedure
   arg position,command_line
   k = position
   cmd_string = substr(command_line,k)
   parse var cmd_string junk ':' file_name junk2
   drive_spec = filespec('d',file_name)
   path_spec  = filespec('p',file_name)
   file_spec  = filespec('n',file_name)
   if drive_spec = '' then drive_spec = left(directory(),2)
   if path_spec  = '' then path_spec  = filespec('p',directory()'\')
   if '\\' = right(path_spec,2) then
      path_spec = reverse(substr(reverse(path_spec),2))
   output_file = drive_spec||path_spec||file_spec
   call Make_Directory output_file
   return output_file


/*
Ŀ
                                                       
  Define global variables                              
                                                       

*/
Define_Globals:
   RXCRC_DLL = 'RXCRC.DLL'
   MSKCHK_DLL= 'MSKCHK.DLL'
   gen_subdir = 0
   gen_text = ''
   globals = ' '                ||,
             'DEBUG '           ||,
             'ourname '         ||,
             'MSKCHK_DLL '      ||,
             'RXCRC_DLL '       ||,
             'RXCRC_RC '        ||,
             'command_line '    ||,
             'phase_type '      ||,
             'gen_subdir '      ||,
             'gen_drive_list. ' ||,
             'gen_output_file ' ||,
             'gen_path_list. '  ||,
             'gen_file_list. '  ||,
             'gen_text '        ||,
             'start_time '      ||,
             'start_tod '       ||,
             ' '
   return


/*
Ŀ
                                                       
  Exit():  display error msg and exit code 1           
                                                       

*/
Exit: procedure
   parse arg message
   say message
   say 'Terminating due to error.'
   exit 1


/*
Ŀ
                                                       
  Gen_Generate()  process CRC generation               
  Input:  gen_file_list. stem var                      
  Output: output file written                          

*/
Gen_Generate: procedure expose (globals)

   myrc = stream(gen_output_file,'c','open write')
   if \abbrev(myrc,'READY') then
      call exit 'Unable to open file' gen_output_file 'for output.'
   if gen_text <> '' then header_text = gen_text
   else header_text = gen_output_file date('s')'@'time('n')
   call lineout gen_output_file,'{hdr}'header_text

   time_left = format(gen_file_list.0 / 4.7,,1)
   nzero_cnt = 0
   call charout ,'Processing file =' d2c(27)'[s'
   do i = 1 to gen_file_list.0
      call charout ,d2c(27)'[u'd2c(27)'[8C'd2c(27)'[2A'||,
         format(time_left-format(i/4.7,,1),,1) 'secs left   '
      call charout ,d2c(27)'[u'i
      file_name = gen_file_list.i
      myrc = stream(file_name,'c','open read')
      file_size = stream(file_name,'c','query size')
      if \abbrev(myrc,'READY') | file_size = 0 then
         do
            call lineout gen_output_file,,
               copies(' ',7)'0 'copies(' ',8)'0 ' file_name
         end
      else
         do
            nzero_cnt = nzero_cnt + 1
            file_size = right(copies(' ',9)||file_size,9)

            file_data = charin(file_name,,chars(file_name))
            call stream file_name,'c','close'
            crc_data = rxcrc(file_data)

            call lineout gen_output_file,,
               crc_data file_size ' 'file_name
         end
   end
   call stream gen_output_file,'c','close'
   end_time = time('s')
   elapsed_time = end_time-start_time
   call charout ,d2c(27)'[u'd2c(27)'[8C'd2c(27)'[1A'||,
      '/gen phase done:' nzero_cnt 'data files, '||,
      gen_file_list.0 - nzero_cnt 'nulls'
   call charout ,d2c(27)'[u'd2c(27)'[8C'||,
      'Elapsed time =' elapsed_time 'secs, '||,
      format(nzero_cnt/elapsed_time,,2) 'files/sec'
   say ''
   return


/*
Ŀ
                                                       
  Gen_Get_Drive_List:  assemble list of drives         
                                                       
  Input:  gen_drive_arg                                
  Output: gen_drive_list. stem var                     

*/
Gen_Get_Drive_List: procedure expose (globals)

   arg drive_arg
   select
      when '(' = left(drive_arg,1) then
         cnt = Parse_Var(drive_arg,'gen_drive_list')

      when '/L' = drive_arg | '/R' = drive_arg | '*' = drive_arg then
         do
            select
               when '/L' = drive_arg then drive_type = 'LOCAL'
               when '/R' = drive_arg then drive_type = 'REMOTE'
               otherwise drive_type = 'USED'
            end
            drive_map = sysdrivemap('C:',drive_type)
            j = 0
            do i = 1 to length(drive_map) by 3
               j = j + 1
               gen_drive_list.j = substr(drive_map,i,1)
            end
            gen_drive_list.0 = j
         end
      when '@' = left(drive_arg,1) then
         drive_cnt = Read_File_Var(drive_arg,'gen_drive_list')
      otherwise
         do
            gen_drive_list.1 = drive_arg
            gen_drive_list.0 = 1
         end
   end
   return


/*
Ŀ
                                                       
  Gen_Get_File_List:   assemble list of files          
                                                       

*/
Gen_Get_File_List:
   arg file_arg
   select

      /* handle list format of operand */
      when '(' = left(file_arg,1) then
         cnt = Parse_Var(file_arg,'gen_file_list')

      /* handle indirect filename format of operand */
      when '@' = left(file_arg,1) then
         file_cnt = Read_File_Var(file_arg,'gen_file_list')

      /* otherwise the list consists of just one entry */
      otherwise
         do
            gen_file_list.1 = file_arg
            gen_file_list.0 = 1
         end
   end

   /* display the entries in the list after processing operands */
   call charout ,'files  = '
   do i = 1 to gen_file_list.0
      call charout ,gen_file_list.i' '
   end
   say ''
   return


/*
Ŀ
                                                       
  Gen_Get_Path_List:   assemble list of paths          
                                                       

*/
Gen_Get_Path_List:
   arg path_arg
   select

      /* handle list format of operand */
      when '(' = left(path_arg,1) then
         cnt = Parse_Var(path_arg,'gen_path_list')

      /* handle indirect filename format of operand */
      when '@' = left(path_arg,1) then
         path_cnt = Read_File_Var(path_arg,'gen_path_list')

      /* otherwise list is single entry */
      otherwise
         do
            gen_path_list.1 = path_arg
            gen_path_list.0 = 1
         end
   end
   return

/*
Ŀ
                                                       
  Load required .dll files, including rexxutil.dll     
                                                       
    Input:  none                                       
    Returns 0: successful                              
            1: error                                   
    Calls:  search_file                                

*/
Load_DLLs: procedure expose (globals)
   myrc = rxfuncquery('sysloadfuncs')
   if myrc <> 0 then
      do
         say 'LOADING REXXUTIL FUNCTIONS'
         call rxfuncadd 'sysloadfuncs','rexxutil','sysloadfuncs'
         call sysloadfuncs
      end

   myrc = rxfuncquery('rxcrc')
   if myrc <> 0 then
      do
         SAY 'LOADING RXCRC FUNCTION.'
         myrc = rxfuncadd('rxcrc','rxcrc','rxcrc')
         if myrc = 1 then
            do
               say 'RXCRC unable to load RXCRC.DLL file. '||,
                   'LIBPATH does not contain file.'
               say 'Attempting recovery by searching for file.'
               mydll = search_file(RXCRC_DLL)
               if mydll = '' then
                  call exit 'Unable to recover.' RXCRC_DLL 'file not found.'
               myrc = rxfuncadd('rxcrc',mydll,'rxcrc')
               if myrc <> 0 then
                  call exit 'Found' mydll 'file, but unable to load file.'
            end
      end

   myrc = rxfuncquery('MaskCheck')
   if myrc <> 0 then
      do
         myrc = rxfuncadd('MaskCheck','mskchk','MaskCheck')
         if myrc = 1 then
            do
               say 'RXCRC unable to load MSKCHK.DLL file. '||,
                   'LIBPATH does not contain file.'
               say 'Attempting recovery by searching for file.'
               mydll = search_file(MSKCHK_DLL)
               if mydll = '' then
                  call exit 'Unable to recover.' MSKCHK_DLL 'file not found.'
               myrc = rxfuncadd('MaskCheck','mskchk','MaskCheck')
               if myrc <> 0 then
                  call exit 'Found' mydll 'file, but unable to load file.'
            end
      end
   return


/*
Ŀ
                                                       
  Make_Directory():  create needed directories         
                                                       
  Input:  drive:\path\file_spec                        
  Output:  created directories                         
  Returns: null                                        

*/
Make_Directory: procedure
   arg file_spec
   path_spec  = filespec('p',file_spec)
   /* note:  format:  \name\ */
   drive_spec = filespec('d',file_spec)
   count = 0
   do i = 1 to length(file_spec)
      if '\' = substr(file_spec,i,1) then count = count + 1
   end
   if count < 2 then return

   /* strip off trailing character */
   chk_path = reverse(substr(reverse(path_spec),2))
   call sysfiletree drive_spec||chk_path,'dirstem.','DO'
   if dirstem.0 > 0 then return
   mkdir = drive_spec
   do while chk_path <> ''
      parse var chk_path new_dir '\' chk_path
      if new_dir = '' & chk_path <> '' then iterate
      if new_dir <> '' then
         do
            mkdir = mkdir'\'new_dir
            call sysmkdir mkdir
         end
   end
   return


/*
Ŀ
                                                       
  Parse command line arguments                         
                                                       
  input:  command_line                                 
  returns:  creates and updates global variables       
  exit:  abort via exit 1 on errors                    

*/
Parse_Arguments:

   say ourname command_line
   k = pos('/DEBUG',translate(command_line))
   if k > 0 then DEBUG = 1
   else DEBUG = 0
   if DEBUG then trace 'r'

   /* count quotes for syntax */
   quote = 0
   do i = 1 to length(command_line)
      if '"' = substr(command_line,i,1) then
         if quote then quote = 0
         else quote = 1
   end
   if quote then
      call exit 'Unmatched quotes on command line:' command_line
   drop quote

   /* count parens for syntax */
   paren = 0
   do i = 1 to length(command_line)
      if '(' = substr(command_line,i,1) then paren = paren + 1
      if ')' = substr(command_line,i,1) then paren = paren - 1
      if paren < 0 then
         call exit 'Invalid use of parentheses on command line:' command_line
   end
   if paren <> 0 then
      call exit 'Unmatched parens on command line:' command_line
   drop paren

   /* Check for /gen or /compare keywords */

   if 0 < pos('/G',translate(command_line)) then phase_gen = 1
   else phase_gen = 0

   if 0 < pos('/C',translate(command_line)) then phase_com = 1
   else phase_com = 0

   if phase_gen & phase_com then
      call exit 'Both /gen & /compare specified on command line.'
   if \(phase_gen | phase_com) then
      call exit 'Neither /gen nor /compare specified on command line.'
   if phase_gen then phase_type = 'GEN'
   if phase_com then phase_type = 'COM'
   drop phase_gen phase_com

   if phase_type = 'GEN' then call Parse_GEN
   else call Parse_COM

   return


/*
Ŀ
                                                       
  Parse_COM parses command_line for /com arguments     
                                                       

*/
Parse_COM: procedure expose (globals)

   say time('n') 'Compare parsing'

   /* DIRECTORY LEVELS */
   com_dir_lvl = 255 /* ALL */
   k = pos('/D:',translate(command_line))
   if k > 0 then
      do
         if 'NONE' = substr(translate(command_line),k+3,4) then
            com_dir_lvl = 0
         if datatype(substr(command_line,k+3,1),'w') then
            do
               cmd_str = substr(command_line,k+3)
               parse var cmd_str com_dir_lvl junk
               if \datatype(com_dir_lvl,'w') then
                  do
                     say 'Warning:  /d:'com_dir_lvl 'ignored: not numeric.'
                     say '/d:1 assumed.'
                     com_dir_lvl = 1
                  end
            end
      end


   /* SORT OPTION */
   com_sort_names = 0
   k = pos('/S:',translate(command_line))
   if k > 0 then
      do
         chk = translate(substr(command_line,k+3,1))
         if 'Y' = chk then com_sort_names = 1
      end



   com_globals = 'DEBUG '           ||,
             'com_data_filea. '     ||,
             'com_data_fileb. '     ||,
             'com_input_filea '     ||,
             'com_input_fileb '     ||,
             'com_name_filea. '     ||,
             'com_name_fileb. '     ||,
             'com_dir_lvl '         ||,
             'com_lines_match '     ||,
             'com_lines_unmat '     ||,
             'com_lines_excep '     ||,
             'com_max_nwidth '      ||,
             'com_output_excep '    ||,
             'com_output_match '    ||,
             'com_output_unmat '    ||,
             'com_sort_names '      ||,
             'com_text_filea '      ||,
             'com_text_fileb '      ||,
             'com_text_excep '      ||,
             'com_text_match '      ||,
             'com_text_unmat '      ||,
             'start_time '          ||,
             'start_tod '           ||,
             'com_max_fsize_filea ' ||,
             'com_max_fsize_fileb ' ||,
             'com_max_fname_filea ' ||,
             'com_max_oline_filea ' ||,
             ' '
   k = pos('/A:',translate(command_line))

   if k > 0 then com_input_filea = Query_Input_File(k,command_line)
   else call exit 'No /a:filea input file specified.'

   k = pos('/B:',translate(command_line))
   if k > 0 then com_input_fileb = Query_Input_File(k,command_line)
   else call exit 'No /b:fileb input file specified.'

   k = pos('/TA:',translate(command_line))
   if k > 0 then com_text_filea = Parse_Text(k,command_line)
   else com_text_filea = com_input_filea

   k = pos('/TB:',translate(command_line))
   if k > 0 then com_text_fileb = Parse_Text(k,command_line)
   else com_text_fileb = com_input_fileb


   k = pos('/M:',translate(command_line))
   if k > 0 then com_output_match = Create_Output_File(k,command_line)
   else com_output_match = systempfilename('RXCRCMAT.???')

   k = pos('/U:',translate(command_line))
   if k > 0 then com_output_unmat = Create_Output_File(k,command_line)
   else com_output_unmat = systempfilename('RXCRCUNM.???')

   k = pos('/X:',translate(command_line))
   if k > 0 then com_output_excep = Create_Output_File(k,command_line)
   else com_output_excep = systempfilename('RXCRCEXC.???')

   k = pos('/TM:',translate(command_line))
   if k > 0 then com_text_match = Parse_Text(k,command_line)
   else com_text_match = com_output_match date('s') time('n')

   k = pos('/TU:',translate(command_line))
   if k > 0 then com_text_unmat = Parse_Text(k,command_line)
   else com_text_unmat = com_output_unmat date('s') time('n')

   k = pos('/TX:',translate(command_line))
   if k > 0 then com_text_excep = Parse_Text(k,command_line)
   else com_text_excep = com_output_excep date('s') time('n')

   com_data_filea.  = ''
   com_data_filea.0 = 0
   com_cnt_filea    = 0

   /* variables used to record high-water sizes of data strings */
   com_max_fsize_filea = 0
   com_max_fsize_fileb = 0
   com_max_fname_filea = 0
   com_max_oline_filea = 0

   say time('n') 'reading input filea' com_input_filea 'to array'
   do while lines(com_input_filea) > 0
      com_cnt_filea = com_cnt_filea + 1
      input_line = linein(com_input_filea)
      if abbrev(translate(input_line),'{HDR}') then
         do
            if abbrev(com_text_filea,com_input_filea) then
               com_text_filea = substr(input_line,6)
            com_cnt_filea = com_cnt_filea - 1
         end
      else
         com_data_filea.com_cnt_filea = translate(strip(input_line))
   end
   com_data_filea.0 = com_cnt_filea
   call stream com_input_filea,'c','close'
   say time('n') 'extracting names for match filea'
   do i = 1 to com_data_filea.0
      parse var com_data_filea.i crcval fsize fname
      crcval = strip(crcval)
      fsize  = strip(fsize)
      fname  = strip(fname)
      l = length(fsize)
      if l > com_max_fsize_filea then com_max_fsize_filea = l
      l = length(fname)
      if l > com_max_fname_filea then com_max_fname_filea = l

      /* length of crc value is 8, fixed length */
      /* format of output line:
         crcvalue 2_byte_gutter file_size 2_byte_gutter filespec */
      l = 8 + 2 + com_max_fsize_filea + 2 + com_max_fname_filea
      if l > com_max_oline_filea then com_max_oline_filea = l
   end


   com_data_fileb.  = ''
   com_data_fileb.0 = 0
   com_cnt_fileb    = 0
   say time('n') 'reading input fileb' com_input_fileb 'to array'
   do while lines(com_input_fileb) > 0
      com_cnt_fileb = com_cnt_fileb + 1
      input_line = linein(com_input_fileb)
      if abbrev(translate(input_line),'{HDR}') then
         do
            if abbrev(com_text_fileb,com_input_fileb) then
               com_text_fileb = substr(input_line,6)
            com_cnt_fileb = com_cnt_fileb - 1
         end
      else
         com_data_fileb.com_cnt_fileb = translate(strip(input_line))
   end
   com_data_fileb.0 = com_cnt_fileb
   call stream com_input_fileb,'c','close'
   say time('n') 'extracting names for match fileb'
   do i = 1 to com_data_fileb.0
      parse var com_data_fileb.i crcval fsize fname
      fsize = strip(fsize)
      l = length(fsize)
      if l > com_max_fsize_fileb then com_max_fsize_fileb = l
   end

   call Com_Compare

   return 0


/*
Ŀ
                                                       
  Parse_GEN parses command_line for /gen arguments     
                                                       

*/
Parse_GEN: procedure expose (globals)
   k = pos('/T:',translate(command_line))
   if k > 0 then gen_text = Parse_Text(k,command_line)
   else gen_text = ''

   /* Process output file specification */
   k = pos('/O:',translate(command_line))
   if k > 0 then gen_output_file = Create_Output_File(k,command_line)

   /* Process subdirectory specification */
   k = pos('/S:',translate(command_line))
   if k > 0 then
      do
         subdir_arg = translate(substr(command_line,k+3))
         parse var subdir_arg subdir_arg junk
         select
            when 'A' = left(subdir_arg,1) then gen_subdir = 1
            when 'N' = left(subdir_arg,1) then gen_subdir = 0
            otherwise call exit '/s:'subdir_arg 'invalid subdirectory specification.'
         end
      end

   /* Process the drives specification */
   gen_drive_list. = ''
   gen_drive_list.0 = 0
   gen_drive_arg = ''
   k = pos('/D:',translate(command_line))
   if k > 0 then
      do
         gen_arg = substr(command_line,k+3)
         parse var gen_arg gen_drive_arg junk
      end

   if gen_drive_arg = '' then gen_drive_arg = left(directory(),1)
   call Gen_Get_Drive_List gen_drive_arg

   exclude_drive = 0
   do i = 1 to gen_drive_list.0
      chk = translate(gen_drive_list.i)
      if ':' = right(chk,1) then
         do
            if length(chk) = 1 then chk = ''
            else chk = reverse(substr(reverse(chk),2))
         end
      if '-' = left(chk,1) then exclude_drive = 1
      tmp_drv_list.i = chk
   end
   tmp_drv_list.0 = gen_drive_list.0
   j = 0
   do i = 1 to tmp_drv_list.0
      chk = tmp_drv_list.i
      select
         when '/L' = chk | '/R' = chk | '*' = chk then
            do
               select
                  when '/L' = chk then drive_type = 'LOCAL'
                  when '/R' = chk then drive_type = 'REMOTE'
                  otherwise drive_type = 'USED'
               end
               drive_map = sysdrivemap('C:',drive_type)
               do k = 1 to length(drive_map) by 3
                  j = j + 1
                  gen_drive_list.j = substr(drive_map,k,1)
               end
            end
         otherwise
            do
               j = j + 1
               gen_drive_list.j = chk
            end
      end
   end
   drop tmp_drv_list.
   gen_drive_list.0 = j
   if exclude_drive then
      do
         call charout ,'Drives excluded:'
         do i = 1 to gen_drive_list.0
            chk = gen_drive_list.i
            if '-' = left(chk,1) then
               do
                  chk = right(chk,1)
                  call charout ,' 'chk':'
                  gen_drive_list.i = ''
                  do j = 1 to gen_drive_list.0
                     if chk = gen_drive_list.j then
                        gen_drive_list.j = ''
                  end
               end
         end
      end
   if exclude_drive then say ''
   call charout ,'Drives = '
   do i = 1 to gen_drive_list.0
      if gen_drive_list.i <> '' then
         call charout ,gen_drive_list.i': '
   end
   say ''


   /* Process path specification */
   gen_path_list. = ''
   gen_path_list.0 = 0
   gen_path_arg = ''
   k = pos('/P:',translate(command_line))
   if k > 0 then
      do
         gen_arg = substr(command_line,k+3)
         parse var gen_arg gen_path_arg junk
      end
   if gen_path_arg = '' then
      do
         gen_path_arg = filespec('p',directory()'\')
         if right(gen_path_arg,1) = '\' then
            do
               gen_path_arg = reverse(substr(reverse(gen_path_arg),2))
            end
      end
   call Gen_Get_Path_List gen_path_arg
   exclude_path = 0
   gen_exclude_path_list. = ''
   gen_exclude_path_list.0 = 0
   exclude_cnt = 0
   do i = 1 to gen_path_list.0
      chk = strip(translate(gen_path_list.i))
      if chk = '\' then chk = '\\'
      if '\' = right(chk,1) then chk = reverse(substr(reverse(chk),2))
      if '-' = left(chk,1) then
         do
            exclude_path = 1
            exclude_cnt = exclude_cnt + 1
            gen_exclude_path_list.exclude_cnt = substr(chk,2)
            chk = '' /* make null this item in list */
         end
      gen_path_list.i = chk
   end
   gen_exclude_path_list.0 = exclude_cnt
   if exclude_path then
      do i = 1 to gen_exclude_path_list.0
         chk = gen_exclude_path_list.i
            do j = 1 to gen_path_list.0
               if chk = gen_path_list.j then
                  gen_path_list.j = ''
            end
      end
   j = 0
   do i = 1 to gen_path_list.0
      chk = gen_path_list.i
      if chk <> '' then
         do
            j = j + 1
            tmp_path_list.j = chk
         end
   end

   /* path data now contained in tmp_path_list, to be expanded into
      gen_path_list
   */

   tmp_path_list.0 = j
   if gen_subdir then subdir_text = 'S'
   else subdir_text = ''
   path_cnt = 0

   call charout ,'#paths =' d2c(27)'[s'
   /* For each drive, run thru all paths specified */
   do i = 1 to gen_drive_list.0
      chk_drive = gen_drive_list.i||':'
      if chk_drive = '' then iterate

      /* for each path specified */
      do j = 1 to tmp_path_list.0
         chk_path = tmp_path_list.j
         if chk_path = '' then iterate

         /* check to see if the specified entry is a directory */
         if chk_path = '\' then
            do
               pathstem.0 = 1
               pathstem.1 = chk_drive'\'
            end
         else
            call sysfiletree chk_drive||chk_path,'pathstem','DO'
         next_path = 1
         if pathstem.0 > 0 then
            do k = 1 to 1
               call Check_Excluded_Path
               if pathstem.1 <> '' then
                  do
                     path_cnt = path_cnt + 1
                     call charout ,d2c(27)'[u'path_cnt
                     gen_path_list.path_cnt = pathstem.1
                  end
               else next_path = 0
            end

            /* If directory and not excluded, check for subdirectories */
            if next_path & subdir_text = 'S' then
               do
                  call sysfiletree chk_drive||chk_path||'\*.*',,
                     'pathstem','D'subdir_text'O'

                  /* For each directory name found */
                  if pathstem.0 > 0 then
                     do k = 1 to pathstem.0
                        call Check_Excluded_Path
                        if pathstem.k <> '' then
                           do
                             path_cnt = path_cnt + 1
                             call charout ,d2c(27)'[u'path_cnt
                             gen_path_list.path_cnt = pathstem.k
                           end
                     end
               end
      end
   end
   say ''

   gen_path_list.0 = path_cnt
   /* path list is now in gen_path_list. stem var
      Note that this list now contains drives as well.
      Path names are not terminated in '\'.
   */
   call charout ,'paths  = '
   max_display = min(10,gen_path_list.0)
   do i = 1 to max_display
      call charout ,gen_path_list.i' '
   end
   say ''
   if max_display < gen_path_list.0 then
      say '... and' gen_path_list.0 - max_display 'additional directories.'


   /* Obtain list of files to process */
   gen_file_list. = ''
   gen_file_list.0 = 0
   gen_exclude_file_list. = ''
   gen_exclude_file_list.0 = 0

   gen_file_arg = ''
   k = pos('/F:',translate(command_line))
   if k > 0 then
      do
         gen_arg = substr(command_line,k+3)
         parse var gen_arg gen_file_arg junk
      end

   if gen_file_arg = '' then
      gen_file_arg = '*.*'
   call Gen_Get_File_List gen_file_arg

   do i = 1 to gen_file_list.0
      gen_file_list.i = translate(gen_file_list.i)
   end

   /* from list of filespecs specified, move the excluded names to
      the gen_exclude_file_list stem var
   */
   exclude_cnt = 0
   do i = 1 to gen_file_list.0
      if '-' = left(gen_file_list.i,1) then
         do
            exclude_cnt = exclude_cnt + 1
            gen_exclude_file_list.exclude_cnt = substr(gen_file_list.i,2)
            gen_file_list.i = ''
         end
   end
   gen_exclude_file_list.0 = exclude_cnt

   /* for each entry in the excluded names list, check against the
      current entries in the specified filenames
   */
   first_excluded = 1
   do i = 1 to gen_exclude_file_list.0
      chk = gen_exclude_file_list.i
      do j = 1 to gen_file_list.0
         myrc = MaskCheck(chk,gen_file_list.j)
         if myrc = 0 then
            do
               if first_excluded then
                  do
                     first_excluded = 0
                     call charout ,'Filespec excluded =' d2c(27)'[s'
                  end
               gen_file_list.j = ''
               gen_file_excl = gen_file_excl + 1
               call charout ,d2c(27)'[u'gen_file_excl
            end
      end
   end
   if first_excluded then say ''
   drop first_excluded
   say 'Scanning for files ...'

   call charout ,'Number of files = 'd2c(27)'[s'

   /* For each entry in gen_path_list stem var, do sysfiletree with
      filespec from gen_file_list stem var
   */
   /* First, copy the file stem var to a temporary one */
   j = 0
   do i = 1 to gen_file_list.0
      chk = gen_file_list.i
      if chk = '' then iterate
      j = j +1
      tmp_file_list.j = chk
   end
   tmp_file_list.0 = j

   file_cnt = 0
   do i = 1 to gen_path_list.0
      pathname = gen_path_list.i'\'
      if pathname = '\\' then pathname = '\'
      if '\\' = right(pathname,2) then
         pathname = reverse(substr(reverse(pathname),2))
      do j = 1 to tmp_file_list.0
         /* show on screen the directory being processed */
         call charout ,d2c(27)'[u'd2c(27)'[8C' ||,
            pathname||tmp_file_list.j ||,
            d2c(27)'[K'
         call sysfiletree pathname||tmp_file_list.j,'filestem','FO'
         do k = 1 to filestem.0
            fcompare = strip(translate(filestem.k))
            match_mask = 0
            do L = 1 to gen_exclude_file_list.0
               msk = gen_exclude_file_list.L
               myrc = MaskCheck(msk,fcompare)
               if myrc = 0 then match_mask = 1
            end
            if \match_mask then
               do
                  file_cnt = file_cnt +1
                  call charout ,d2c(27)'[u'd2c(27)'[8C'd2c(27)'[1A'||,
                     format(file_cnt/4.9,,1) 'secs left'
                  call charout ,d2c(27)'[u'file_cnt
                  gen_file_list.file_cnt = fcompare
               end
         end
      end
   end
   gen_file_list.0 = file_cnt
   /* erase from screen the directory name last shown */
   call charout ,d2c(27)'[u'd2c(27)'[8CProcessing files...'d2c(27)'[K'
   say ''

   call Gen_Generate

   return 0

Check_Excluded_Path:
   /* Check the excluded names */
   do n = 1 to gen_exclude_path_list.0
      exc_chk = gen_exclude_path_list.n
      exc_var = substr(pathstem.k,3,length(exc_chk))
      exc_sub = substr(pathstem.k,3)
      if exc_chk = exc_var then
         select
            when exc_chk = exc_sub then
               pathstem.k = ''
            when length(exc_sub) > length(exc_chk) then
               if '\' = substr(exc_sub,length(exc_chk)+1,1) then
                  pathstem.k = ''
            otherwise nop
         end
      if pathstem.k = '' then leave
   end
   return

/*
Ŀ
                                                       
  Parse text identifier phrase into variable           
  Input:  position in command_line                     
  returns:  string                                     

*/
Parse_Text: procedure
   parse arg position,command_line
   j = pos('"',command_line,position) /* find open quote */
   L = pos('/',command_line,position+1)
   if L = 0 then L = length(command_line)
   if j = 0 | j > L then
      do
         if L = 0 then L = length(command_line)
         j = pos(':',command_line,position)
         text_string = substr(command_line,j+1,L-j-1)
         text_string = strip(text_string)
      end
   else
      do
         k = pos('"',command_line,j+1)      /* find close quote */
         text_string = substr(command_line,j+1,k-j-1)
      end
   return text_string


/*
Ŀ
                                                       
  Parse_Var() parses a list argument into stem var     
  Input:  argument_string, name of stem variable       

*/
Parse_Var: procedure expose (globals)
   arg arg_string,var_name
   if DEBUG then say 'Parse_var var_name='var_name
   arg_string = strip(arg_string)
   arg_string = reverse(substr(reverse(arg_string),2))
   arg_string = substr(arg_string,2)
   argx = arg_string
   cnt = 0
   do while argx <> ''
      cnt = cnt + 1
      parse var argx args.cnt ',' argx
      argx = strip(argx)
      args.cnt = strip(args.cnt)
   end
   if DEBUG then do i = 1 to cnt; say 'arg='args.i; end
   args.0 = cnt
   if DEBUG then trace 'R'
   do i = 1 to args.0
      args.i = "'"args.i"'"
      interpret interpret '"'var_name'.i="args.i'
      interpret interpret '"'var_name'.0="i'
   end
   if DEBUG then trace 'o'
   return cnt
/*
Ŀ
                                                       
  Query_Input_File(): read contents of input file      
     into variable, passing data thru return value     
                                                       
  Input: position, command_line                        
  returns: name of input file                          

*/
Query_Input_File: procedure
   arg k,command_line
   cmd_string = substr(command_line,k)
   parse var cmd_string junk ':' file_name junk2
   file_spec = stream(file_name,'c','query exists')
   if file_spec = '' then call exit 'Input file' file_name 'does not exist.'
   return file_spec


/*
Ŀ
                                                       
 Read_File_Var()  read a file into a stem var          
                                                       

*/
Read_File_Var: procedure expose (globals)
   arg arg_string,var_name
   arg_string = strip(arg_string)

   if '@' <> left(arg_string,1) then
      call exit 'Internal error: read_file_var called with invalid args'

   file_name = substr(arg_string,2)
   file_spec = stream(file_name,'c','query exists')
   if file_spec = '' then call exit '/d:'arg_string 'file does not exist.'

   cnt = 0
   do while lines(file_spec) > 0
      cnt = cnt + 1
      args.cnt = linein(file_spec)
   end
   call stream file_spec,'c','close'
   args.0 = cnt
   do i = 1 to args.0
      args.i = "'"args.i"'"
      interpret interpret '"'var_name'.i="args.i'
      interpret interpret '"'var_name'.0="i'
   end
   return cnt


/*
Ŀ
                                                       
  Search local drives for file                         
                                                       
    Input:  name of file                               
    Returns full filespec if successful                
            null string if error                       

*/
Search_File: procedure
   arg filename
   full_file_spec = ''
   local_drives = sysdrivemap('c:','local')
   file_found = 0
   do i = 1 to length(local_drives) by 3
      current_drive = substr(local_drives,i,2)
      call sysfiletree current_drive'\'filename,'filestem.','FSO'
      if filestem.0 > 0 then
         do
            full_file_spec = filestem.1
            leave
         end
   end
   return full_file_spec
